#include <stdio.h>
#include <conio2.h>
#include <string.h>
#include "types.h"
#include "Painter.h"

void gotoXY(int x, int y)
{
 gotoxy(x,y);    
}

void PrintIt(char ch,int color, int bg)
{
 textcolor(color);
 textbackground(bg);
 cprintf("%c", ch);
 gotoxy(30,20); 
}

void ClearScreen() 
{
 clrscr();
}

void PaintWall(WallTile theWall, int x, int y)
{
 gotoxy(x, y);
 int Col, bg;
 if(theWall.Colour == ISRED) Col = LIGHTRED;
 else if(theWall.Colour == ISYELLOW) Col = YELLOW;
 else Col = WHITE;
 
 if(theWall.Dirty) bg = BROWN;
 else bg = BLACK;
 
 if(theWall.Hole) PrintIt(176, WHITE, bg);
 else if(theWall.Blocking == BNONE) PrintIt(206, Col, bg);
 else if(theWall.Blocking == BNORTH) PrintIt(203, Col, bg);
 else if(theWall.Blocking == BEAST)  PrintIt(185, Col, bg);
 else if(theWall.Blocking == BSOUTH) PrintIt(202, Col, bg);
 else if(theWall.Blocking == BWEST) PrintIt(204, Col, bg);
 else if(theWall.Blocking == BNORTHEAST) PrintIt(187, Col, bg);
 else if(theWall.Blocking == BNORTHSOUTH) PrintIt(205, Col, bg);
 else if(theWall.Blocking == BNORTHWEST) PrintIt(201, Col, bg);
 else if(theWall.Blocking == BEASTSOUTH) PrintIt(188, Col, bg);
 else if(theWall.Blocking == BEASTWEST) PrintIt(186, Col, bg);
 else if(theWall.Blocking == BSOUTHWEST) PrintIt(200, Col, bg);
 else if(theWall.Blocking == BNORTHEASTSOUTH) PrintIt(181, Col, bg);
 else if(theWall.Blocking == BEASTSOUTHWEST) PrintIt(208, Col, bg);
 else if(theWall.Blocking == BSOUTHWESTNORTH) PrintIt(198, Col, bg);
 else if(theWall.Blocking == BWESTNORTHEAST) PrintIt(210, Col, bg);
 else if(theWall.Blocking == BALL) PrintIt(' ', Col, bg);
}


void PaintCharacter(char* Label, int x, int y, ColourType C, PointAt P)
{
 gotoxy(x, y); 
 int Col;
 if(C == ISRED || C == SETRED) Col = LIGHTRED;
 else if(C == ISYELLOW || C == SETYELLOW) Col = YELLOW;
 else Col = LIGHTGRAY;
 if(Col == LIGHTGRAY)
 {
  if(strcmp("PID", Label) == 0) PrintIt(2, WHITE, BLACK);
  else if(strcmp("CRYSTAL", Label) == 0) PrintIt(4, LIGHTGREEN, BLACK);
  else if(strcmp("CLOSEDEXIT", Label) == 0) PrintIt('X', BLUE, BLACK);
  else if(strcmp("OPENEXIT", Label) == 0) PrintIt(240, LIGHTBLUE, BLACK);
  else if(strcmp("ALLY", Label) == 0) PrintIt(2, LIGHTGRAY, BLACK);
  else if(strcmp("GOLEM", Label) == 0) PrintIt(12, LIGHTMAGENTA, BLACK);
  else if(strcmp("FURY", Label) == 0) PrintIt(157, RED, BLACK);
  else if(strcmp("FLAME", Label) == 0) PrintIt(235, RED, BLACK); 
  else if(strcmp("SWITCH", Label) == 0) PrintIt(232, LIGHTGRAY, BLACK);
  else if(strcmp("DIRT", Label) == 0) PrintIt(176, BROWN, BLACK);      
  else if(strcmp("TRAP", Label) == 0) PrintIt(15, CYAN, BLACK);
  else if(strcmp("ARROW", Label) == 0) 
  {
   if(P == PNORTH) PrintIt(24, LIGHTCYAN, BLACK);
   else if(P == PEAST) PrintIt(26, LIGHTCYAN, BLACK);
   else if(P == PSOUTH) PrintIt(25, LIGHTCYAN, BLACK);
   else if(P == PWEST) PrintIt(27, LIGHTCYAN, BLACK);    
  }
  else if(strcmp("HVBLOCK", Label) == 0) PrintIt('+', LIGHTGREEN, DARKGRAY);
  else if(strcmp("VBLOCK", Label) == 0) PrintIt(18, LIGHTBLUE, DARKGRAY);
  else if(strcmp("HBLOCK", Label) == 0) PrintIt(29, YELLOW, DARKGRAY);  
  else if(strcmp("DBLOCK", Label) == 0) PrintIt(234, WHITE, DARKGRAY);   
 }
 else
 {
  if(strcmp("PID", Label) == 0) PrintIt(2, Col, BLACK);
  else if(strcmp("CRYSTAL", Label) == 0) PrintIt(4, Col, BLACK);
  else if(strcmp("CLOSEDEXIT", Label) == 0) PrintIt('X', Col, BLACK);
  else if(strcmp("OPENEXIT", Label) == 0) PrintIt(240, Col, BLACK);
  else if(strcmp("ALLY", Label) == 0) PrintIt(2, Col, BLACK);
  else if(strcmp("GOLEM", Label) == 0) PrintIt(12, Col, BLACK);
  else if(strcmp("FURY", Label) == 0) PrintIt(157, Col, BLACK);
  else if(strcmp("FLAME", Label) == 0) PrintIt(235, Col, BLACK); 
  else if(strcmp("SWITCH", Label) == 0) PrintIt(232, Col, BLACK);
  else if(strcmp("DIRT", Label) == 0) PrintIt(176, Col, BLACK);      
  else if(strcmp("TRAP", Label) == 0) PrintIt(15, Col, BLACK);
  else if(strcmp("ARROW", Label) == 0) 
  {
   if(P == PNORTH) PrintIt(24, Col, BLACK);
   else if(P == PEAST) PrintIt(26, Col, BLACK);
   else if(P == PSOUTH) PrintIt(25, Col, BLACK);
   else if(P == PWEST) PrintIt(27, Col, BLACK);    
  }
  else if(strcmp("HVBLOCK", Label) == 0) PrintIt('+', Col, DARKGRAY);
  else if(strcmp("VBLOCK", Label) == 0) PrintIt(18, Col, DARKGRAY);
  else if(strcmp("HBLOCK", Label) == 0) PrintIt(29, Col, DARKGRAY);  
  else if(strcmp("DBLOCK", Label) == 0) PrintIt(234, Col, DARKGRAY);    
 }
}


