#include "list.h"

void freeList(TList theList)
{
	theList.Current = theList.Head;

	while (theList.Current != NULL) 
	{ 	 
		theList.Current = theList.Head->next;
		free(theList.Head);
		theList.Head = theList.Current;
	}
}

TList removeNodes(TList theList)
{     
	theList.Current = theList.Head;
	if(theList.Current == NULL) return theList;
    theList.Current = theList.Current->next;
	while(theList.Head->theTile.RemoveMe) 
	{                                       
        if(theList.Head->theTile.Collected) theList.NumCollects--;
        else if(theList.Head->theTile.Important) theList.GameOver = true;
        free(theList.Head);
		theList.Head = theList.Current;
        if(theList.Current != NULL) theList.Current = theList.Current->next;
        else return theList;
	}
	TNode* prev = theList.Head;

    while(theList.Current != NULL)
	 {                          
	  TNode* temp = theList.Current;
	  theList.Current = theList.Current->next;
 	  if(temp->theTile.RemoveMe) 
      {                                 
        prev->next = temp->next;
        if(temp->theTile.Collected) theList.NumCollects--;
        else if(temp->theTile.Important) theList.GameOver = true;        
        free(temp);	    
      } else prev = prev->next;
     }
 
 
 theList.Current = theList.Head;
 return theList;  
}

TList addNode(TList theList, PlayTile newTile)
{
	TNode* newNode = (TNode*)malloc(1000);
 
	newNode->theTile = newTile;
	if(newTile.Collect == COLLECTABLE) theList.NumCollects++;
    newNode->ID = 0;
	newNode->next = NULL;
 	
	if (theList.Head == NULL)
	{
		theList.Head = newNode;
		theList.Current = theList.Head;
		theList.Head->next = NULL;
		theList.Current->next = NULL;
	}
	else
	{
		theList.Current = theList.Head;  
		newNode->ID++;
		while(theList.Current->next != NULL)
		{
			theList.Current = theList.Current->next;
			newNode->ID++;
        }

		theList.Current->next = newNode;
	}

	return theList;
}

TList CreateNewTList()
{
	TList theList;
	theList.NumCollects = 0;
	theList.GameOver = false;
	theList.GetGems = true;
	theList.Winner = false;
	theList.Head = NULL;
	theList.Current = NULL;
	theList.Current = theList.Head;
 
	return theList;
}

TList SwitchOverCollect(TList theList)
{
 theList.Current = theList.Head;
 while(theList.Current != NULL)
 {
  if(strcmp("CLOSEDEXIT", theList.Current->theTile.Name) == 0)  theList.Current->theTile.Name = "OPENEXIT\0";
  if(theList.Current->theTile.Collect == COLLECTOR || theList.Current->theTile.Collect == COLLECTMEWAIT) 
  {
    theList.Current->theTile.Collect = COLLECTABLE;
    theList.NumCollects++;
  }
  else if(theList.Current->theTile.Collect == COLLECTWAIT) theList.Current->theTile.Collect = COLLECTOR;  
  theList.Current = theList.Current->next;
 }   
 return theList;
}

TList ResetList(TList theList)
{
	if(theList.GetGems && theList.NumCollects == 0)
	{
     theList = SwitchOverCollect(theList);   
     theList.GetGems = false;                
    }
    else if(!theList.GetGems && theList.NumCollects == 0) theList.Winner = true;
  	theList.Current = theList.Head;
	return theList;      
}

TList nextNode(TList theList)
{
	theList.Current = theList.Current->next;

	return theList;	
}

TList SwapNodes(TList theList, TNode* First, TNode* Second)
{
 PlayTile TempT = First->theTile;
 int TempID = First->ID;
 
 First->theTile = Second->theTile;
 First->ID = Second->ID;
 Second->theTile = TempT;
 Second->ID = TempID;
 
 return theList;
}

void PrintList(TList theList)
{
  TNode* traverse = theList.Head;
  while(traverse != NULL)
  {
   printf("%d ", traverse->ID);
   traverse = traverse->next;
  }   
  printf("\r\n");
}
